<template>
    <div class="animated fadeIn">
        <b-row>
            <b-col sm="12">
                <b-card header="<i class='fa fa-align-justify'></i> Daftar Item">
                    <table class="table table-bordered table-sm">
                        <thead>
                            <tr>
                            <th scope="col">#</th>
                            <th scope="col">Kode</th>
                            <th scope="col">Nama</th>
                            <th class="text-center"> 
                                <b-button @click="tambah()" variant="primary" class="btn-pill" size="sm">
                                    <i class="fa fa-plus-o"></i>&nbsp;Tambah
                                </b-button>
                            </th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="(i, index) in dataPage.content" :key="index">
                                <td scope="row">{{i.id}}</td>
                                <td>{{i.kode}}</td>
                                <td>{{i.nama}}</td>
                                <td class="text-center">
                                    <b-button variant="default" class="btn-pill" size="sm" @click="ubah(i)">
                                        <i class="fa fa-pencil"></i>&nbsp;Ubah
                                    </b-button>
                                    <b-button variant="danger" class="btn-pill" size="sm" v-on:click="hapus(i)">
                                        <i class="fa fa-trash-o"></i>&nbsp;Hapus
                                    </b-button>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <nav>
                        <b-pagination :total-rows="dataPage.totalElements" 
                            :per-page="dataPage.size" v-model="pageNumber" 
                            @input="movePage"
                            prev-text="Prev" next-text="Next" hide-goto-end-buttons/>
                    </nav>
                </b-card>
            </b-col>
        </b-row>

        <b-modal ref="formModalRef" hide-footer :title="modalTitle">
            <div class="d-block text-center">
                <b-container fluid>
                    <b-form>
                        <b-form-group
                            label="Kode"
                            label-for="kode"
                            :label-cols="2"
                            :horizontal="true">
                            <b-form-input v-model="vm.kode" id="kode" type="text" autocomplete="kode"></b-form-input>
                        </b-form-group>
                        <b-form-group
                            label="Nama"
                            label-for="nama"
                            :label-cols="2"
                            :horizontal="true">
                            <b-form-input v-model="vm.nama" id="nama" type="text" autocomplete="satuan"></b-form-input>
                        </b-form-group>
                    </b-form>
                </b-container>
            </div>
            <b-btn class="mt-1" variant="outline-danger" block @click="simpan">Simpan</b-btn>
            <b-btn class="mt-1" variant="outline-danger" block @click="hideModal">Close Me</b-btn>
        </b-modal>
    </div>
</template>

<script>
import http from "@/http-common"

export default {

    name: "item-list",
    data(){
        return {
            modalTitle: "Tambah Item",
            vm: {},
            dataPage: {},
            pageNumber: 1
        }
    },
    methods:{
        tambah(){
            this.vm = {};
            this.$refs.formModalRef.show()
        },
        simpan(){
            http.post("/master/ruang", this.vm)
            .then(res => {
                this.ambilDataItem()
                this.$refs.formModalRef.hide()
            })
            .catch(e => {
                console.log("eror", e)
            })
        },
        hapus(item){
            var r = confirm("Anda yakin untuk menghapus item '"+item.nama+"'?");
            if (r == true) {
                http.delete("/master/ruang/"+item.id)
                        .then(res =>{
                            this.ambilDataItem()
                        })
            }
            
        },
        ambilDataItem(){
            http.get("/master/ruang", {params:{page: this.pageNumber-1, size: 10}})
            .then(res => {
                this.dataPage = res.data
                //Console.log('response.data', res.data)
            })
            .catch(e => {
                Console.log("eror", e)
            })
        },
        refresh(){
            this.pageNumber=0;
            this.ambilDataItem();
        },
        movePage(){
            this.ambilDataItem();
        },
        ubah(item){
            this.modalTitle = "Ubah Item"
            this.vm = JSON.parse(JSON.stringify(item))
            this.$refs.formModalRef.show()
        },
        hideModal () {
            this.$refs.formModalRef.hide()
        }
    },
    mounted(){
        this.ambilDataItem();
    },
    filters: {
        angka (value) {
        return `${value.toLocaleString()}`
        }
    }
}
</script>

<style>
    .pagination {
        justify-content: center;
    }
</style>
